// 1D example
// zero noise
ftest=sin; // Response function

x_bound=[-2; 2];
X=(linspace(x_bound(1),x_bound(2),4))'; // Points of experiment
YExp=ftest(X);// Response values

noise=0;theta=1
[kmodel] =km(X,YExp,0,'gaussian',theta,noise);// creates kriging model  (constant trend)
//[kmodel] =km(X,YExp,0,'matern_5_2',theta,noise);// creates kriging model  (constant trend)
//[kmodel] =km(X,YExp,0,'exponential_1_9',theta,noise);// creates kriging model  (constant trend)


lob   = [0.1];upb   = [2];
[kmodel p]=findTheta(kmodel,lob,upb,'MLL','RS',200);// searches for optimal thetas
//[kmodel p]=findTheta(kmodel,lob,upb,'CV','RS',200);// searches for optimal thetas
////[kmodel p]=findTheta(kmodel,lob,upb,'MLL','NM',200);// searches for optimal thetas


Xtest=(linspace(x_bound(1),x_bound(2),100))'; // 100 point test sample
[YX vY]=predict(kmodel,Xtest); // kriging prediction



// plots
scf();
xtitle('Kriging prediction, data points and test function');
plot(Xtest,YX,'k+');
plot(Xtest,ftest(Xtest));
plot(X,YExp,'r+');
a=gca(); 
 a.data_bounds=a.data_bounds.*[1.1,1;1.1,1];
 a.tight_limits="on";
legend('kriging prediction','test function','data points');



// Simulate conditional Gaussian
kmodel.noise=0.000001;// add small noise for numerical stabillity
 
[Sim1]=SimCondGaussian(Xtest,kmodel,50); 
scf;
xtitle('Simulation of Conditional Gaussian processes and Kriging mean');
plot(Xtest,Sim1,'k'); // simulations
plot(Xtest,YX,'r');// Kriging mean

showModel(kmodel)
