// 1D example 
// known parameters

ftest=sin; // test function

x_bound=[-2; 2];
X=(linspace(x_bound(1),x_bound(2),4))'; // Points of experiment


YExp=ftest(X);// Response at experiment



noise=0;theta=0.8; sigma=1; Beta=0;
[kmodel] =km(X,YExp,0,'gaussian',theta,noise,Beta,sigma);// creates kriging model


Xtest=(linspace(x_bound(1),x_bound(2),100))'; // test points
[YX vY]=predict(kmodel,Xtest); // kriging prediction at test points


// plot: 
scf();
plot(Xtest,YX,'k+');// kriging prediction
plot(Xtest,ftest(Xtest));// true funciton
plot(X,YExp,'r+'); // points used for model creation
a=gca(); 
 a.data_bounds=a.data_bounds.*[1.1,1;1.1,1];
 a.tight_limits="on";
xtitle('Test case','x','f');
legend('kriging prediction','Test function','Observations',4);
 

// simulate conditional Gaussian 
kmodel.noise=%eps*1000;
ns=500;//number of simulations
[Sim1]=SimCondGaussian(Xtest,kmodel,ns);

//plot:
scf;
plot(Xtest,Sim1,'k'); // simulations
plot(Xtest,YX,'r');// Kriging mean
plot(Xtest,mean(Sim1,'c'),'b');// sampled mean
xtitle('Simulations of Conditional Gaussian processes, kriging mean, mean of simulations');

//plot:
scf;
plot(Xtest,variance(Sim1,'c'),'r');// sampled variance
[m,vr1]=predict(kmodel,Xtest);
plot(Xtest,vY,'b');// predicted variance SK

kmodel.estimateBeta=-1;
[YX vY]=predict(kmodel,Xtest); // kriging prediction
plot(Xtest,vY,'k');// predicted variance UK
xtitle('Sampled variance, predicted varaince');
legend('variance sampled simulations','predicted varaince SK','predicted variance UK');
showModel(kmodel)
