// 1D example noisy function 
// creates kriging model,
// estimate all parameters
//
ftest=sin; // test funciton

x_bound=[-2; 2];
X=(linspace(x_bound(1),x_bound(2),8))'; // Points of experiment


YExp=ftest(X);
noise=0.3;// noise  of stdev;
Sd=st_deviation(YExp)*noise;
YExp=YExp+ grand(size(YExp,'r'),1,'nor',0,Sd);//add noise on experiments


theta=1;
[kmodel] =km(X,YExp,0,'gaussian',theta);// creates kriging model

lob   = [0.1];upb   = [8];
[kmodel p]=findTheta(kmodel,lob,upb,'MLL','RS',200);// searches for optimal thetas, sigma and noise
//[kmodel p]=findTheta(kmodel,lob,upb,'CV','RS',200);// searches for optimal thetas, using LOOCV
//[kmodel p]=findTheta(kmodel,lob,upb,'MLL','CMA',200);// searches for optimal thetas, using CMAES
kmodel.MLL

//noise=0;theta=1;
//[kmodel] =km(X,YExp,0,'gaussian',theta);// creates kriging model
//[kmodel p]=findTheta(kmodel,lob,upb,'MLL','NM',200);// searches for optimal thetas
//kmodel.MLL


Xtest=(linspace(x_bound(1),x_bound(2),100))'; // test points
[YX vY]=predict(kmodel,Xtest); // kriging prediction

// plot 
scf();
plot(Xtest,YX,'k+');
plot(Xtest,ftest(Xtest));
plot(X,YExp,'r+');
a=gca(); 
 a.data_bounds=a.data_bounds.*[1.1,1;1.1,1];
 a.tight_limits="on";

plot(Xtest, YX+2*sqrt(vY),'r')
plot(Xtest, YX-2*sqrt(vY),'r')
legend('kriging mean','testfunction (without noise)','noisy experiments','kriging mean +2*sigma','kriging mean -2*sigma',4);
xtitle('kriging, tes funciton, 2*Sigma of prediction'); 

showModel(kmodel)
