// 2D example
// Kriging model creation, parameter estimation
//

function [f]=cmb_2(x)
// test functions
 x1=x(:,1);x2=x(:,2);
//f=(4-2.1*x1*x1+x1^4/3)*x1*x1+x1*x2+(-4+4*x2*x2)*x2*x2
f=(4-2.1*x1.*x1+(x1^4)/3).*x1.*x1+x1.*x2+(-4+4*x2.*x2).*x2.*x2
endfunction


x_bound=[-1 -1; 1 1];//for 2- hump camell back function

 
ftest=cmb_2;
X=RLHS(20,2,x_bound(1,:),x_bound(2,:))
YExp=ftest(X);




noise=0;theta=[1 1];
  
lob   = [0.1]*ones(1,2);upb   = [4]*ones(1,2);

//[kmodel] =km(X,YExp,0,'gaussian',theta,noise);// creates kriging model
//[kmodel p]=findTheta(kmodel,lob,upb,'MLL','CMA',400);// searches for optimal thetas, sigma and noise
//kmodel.MLL

//[kmodel] =km(X,YExp,0,'gaussian',theta,noise);// creates kriging model
//[kmodel p]=findTheta(kmodel,lob,upb,'MLL','NM',400);// searches for optimal thetas, sigma and noise
//kmodel.MLL

[kmodel] =km(X,YExp,0,'gaussian',theta,noise);// creates kriging model
[kmodel p]=findTheta(kmodel,lob,upb,'MLL','RS',400);// parameter estimation - searches for optimal thetas, sigma and noise
kmodel.MLL



//print(kmodel);
printf("Rel. RMSE of Cross Validation: %f\n",LOOCV(kmodel));// Relative RMSE of Cross Validation

Xtest=RLHS(1000,2,x_bound(1,:),x_bound(2,:)); // test points

//kmodel.estimateBeta=1;
[YX VY]=predict(kmodel,Xtest); // kriging prediction
//[YX]=predict(kmodel,Xtest); // kriging prediction without variance


// callculates Relative RMSE at test points
MSE=(sum((ftest(Xtest)-YX).^2))/size(Xtest,'r');
vY=variance(ftest(Xtest));
RRMSE=100*sqrt(MSE/vY);
printf("Rel. RMSE: %f\n",RRMSE);

// callculates R square at test points
R2=1-sum((ftest(Xtest)-YX).^2)/sum((ftest(Xtest)-mean(ftest(Xtest))).^2);
printf("R square: %f\n",R2);

  
// plot kriging prediction  
X1=(linspace(x_bound(1,1),x_bound(2,1),30));
X2=(linspace(x_bound(1,2),x_bound(2,2),30))';
X1=ones(size(X1,'c'),1)*X1;
X2=X2*ones(1,size(X2,'r'));

Xresp=[];
for i=1 :size(X2,'c')
    Xresp=[Xresp predict(kmodel,[X1(:,i) X2(:,i)])];
end;
scf;
mesh(X1,X2,Xresp);
xtitle('kriging predicted mean');

// plot contour lines
scf;
xlabel('x');
ylabel('y');
contour(X1(1,:),X2(:,1),Xresp',20)
plot(X(:,1),X(:,2),'b.');
xtitle('kriging predicted mean and DOE');


scf;
// plot actual function 
X1=(linspace(x_bound(1,1),x_bound(2,1),30));
X2=(linspace(x_bound(1,2),x_bound(2,2),30))';
X1=ones(size(X1,'c'),1)*X1;
X2=X2*ones(1,size(X2,'r'));

Xresp=[];
for i=1 :size(X2,'c')
    Xresp=[Xresp ftest([X1(:,i) X2(:,i)])];
end;
mesh(X1,X2,Xresp);
xtitle('test function');


///// plot exact vs fitted

scf;
plot(ftest(Xtest),YX,'r.');

a=gca();
l=[min(a.data_bounds);max(a.data_bounds)];
plot(l,l,'k-');
xtitle('Fitted vs Exact ','Exact values','Fitted values');


showModel(kmodel)

