// 5D example
// kriging model creation, parameter estimation
// unknown parameters
// CMAES calles with specail parameter settings
//
function [f]=st_tf(x)
  //pause;
  n=size(x,'r');
f=(ones(n,1)./(1+sum((x(:,:)-0.05).^2,'c'))-ones(n,1)./(1+sum((x(:,:)+0.05).^2,'c')));
//pause
endfunction


ftest=st_tf; // test funciton

x_bound=[-1; 1];
X=RLHS(50,5,ones(1,5)*x_bound(1),ones(1,5)*x_bound(2)); 

YExp=ftest(X);

noise=0;theta=[1 1 1 1 1];
lob   = [0.1]*ones(1,5);upb   = [2]*ones(1,5);

//CMA-ES based search
[kmodel] =km(X,YExp,0,'gaussian',theta,noise);// creates kriging model

maxiter=2000;
//define custom CMA-ES parameters
p = struct();
		p.x0 = ((upb-lob)/1+lob)';  // mandatory: initial solution vector  
		p.sigma0 = 0.5;     // mandatory: initial standard deviation on x0 
		p.opt.scaling_of_variables = (upb -lob)'; 
		p.opt.lambda=10; // population size
		p.stop.maxfunevals= maxiter;
		p.stop.tolfun =kmodel.MLL*10^-4; // stop optimization if improvement in objective is less than 
		p.stop.readme.tolx =0.01;// 'stop if x-changes are smaller than tolx*sigma0*scaling';  			

[kmodel p]=findTheta(kmodel,lob,upb,'MLL','CMA',,p);// searches for optimal thetas, sigma and noise eith 
kmodel.MLL


printf("Rel. RMSE of Cross Validation: %f\n",LOOCV(kmodel));// Relative RMSE of Cross Validation

Xtest=RLHS(10000,5,ones(1,5)*x_bound(1),ones(1,5)*x_bound(2)); // test points

[YX vY]=predict(kmodel,Xtest); // kriging prediction

// callculates Realtive RMSE at test points
MSE=(sum((ftest(Xtest)-YX).^2))/size(Xtest,'r');
vY=variance(ftest(Xtest));
printf("Rel. RMSE: %f\n",RRMSE=100*sqrt(MSE/vY));
  

///// plot exact vs fitted

scf;
plot(ftest(Xtest),YX,'r.');

a=gca();
l=[min(a.data_bounds);max(a.data_bounds)];
plot(l,l,'k-');
xtitle('Fitted vs Exact ','Exact values','Fitted values');


showModel(kmodel)
