// demo 2D
function [f]=cmb_2(x)
 x1=x(:,1);x2=x(:,2);
f=(4-2.1*x1.*x1+(x1^4)/3).*x1.*x1+x1.*x2+(-4+4*x2.*x2).*x2.*x2
endfunction



ftest=cmb_2; 
x_bound=[-1.9 -1.1 ;1.9 1.1 ];
//ftest=st_tf; 
//x_bound=[-1 -1 ;1 1 ];


// sometimes this initial design can be very deceptive
X=RLHS(20,2,x_bound(1,:),x_bound(2,:));// generates random Latin hypercube initial sample

YExp=ftest(X);


[kmodel] =km(X,YExp,0,'gaussian',[1 1],0);
//[kmodel] =km(X,YExp,0,'matern_5_2',[1 1],%eps*1000);//kmodel.estimateNoise=0;

upb=(x_bound(2,:)-x_bound(1,:))*2;
lob=ones(x_bound(2,:))*0.0001;

[kmodel p]=findTheta(kmodel,lob,upb,'MLL','CMA',500);

lob=x_bound(1,:);//[-1 -1];
upb=x_bound(2,:);//[1 1];
maxit=10  ;

opt=EGO(kmodel,lob,upb,maxit,0,'CMA',500,,%t);

while ~EGO_stop(opt)

  [x,opt]=EGO_ask(opt);
  opt=EGO_tell(opt,x,ftest(x));

end;



//___ plot contour
X1=(linspace(x_bound(1,1),x_bound(2,1),30));
X2=(linspace(x_bound(1,2),x_bound(2,2),30))';
X1=ones(size(X1,'c'),1)*X1;
X2=X2*ones(1,size(X2,'r'));

Xresp=[];
for i=1 :size(X2,'c')
    Xresp=[Xresp ftest([X1(:,i) X2(:,i)])];
end;
scf;
xtitle('Contour lines of test function, points of optimization, initial points');
contour(X1(1,:),X2(:,1),Xresp',10)

// plot points
[ybest xbest]=EGO_best(opt);
for it=1:opt.it
  plot(opt.perfData.maxEix(it,1),opt.perfData.maxEix(it,2),'r.');
 end;
plot(X(:,1),X(:,2),'b.');//initial points


// plot 3D 
X1=(linspace(x_bound(1,1),x_bound(2,1),30));
X2=(linspace(x_bound(1,2),x_bound(2,2),30))';
X1=ones(size(X1,'c'),1)*X1;
X2=X2*ones(1,size(X2,'r'));

Xresp=[];
for i=1 :size(X2,'c')
    Xresp=[Xresp predict(opt.kmodel,[X1(:,i) X2(:,i)])];
end;
scf;
xtitle('Kriging surface for last iteration');
mesh(X1,X2,Xresp);


///plot  EI for 2D

X1=(linspace(x_bound(1,1),x_bound(2,1),30));
X2=(linspace(x_bound(1,2),x_bound(2,2),30))';
X1=ones(size(X1,'c'),1)*X1;
X2=X2*ones(1,size(X2,'r'));

Xresp=[];
for i=1 :size(X2,'c')
    Xresp=[Xresp EI(opt,[X1(:,i) X2(:,i)])];
end;

scf;
xtitle('EI for last iteration');
mesh(X1,X2,Xresp);
//contour(X1(1,:),X2(:,1),Xresp',10);

