// Gaussian process trajectory simulation


// zero trend
Xtest=(linspace(-1,1,100))';
Y=simGaussian(Xtest,'gaussian',0.3,%eps*100,ns=10 );
scf;
plot(Xtest,Y)



// linear trend
Y=simGaussian(Xtest,'gaussian',0.2,%eps*100,1,[5 ;3],ns=10 );
scf;
plot(Xtest,Y)


//sin trend
Xtest=(linspace(-1,3,100))';
Y=simGaussian(Xtest,'gaussian',0.2,%eps*100,sin,[0.5],0.005,ns=5 );
scf;
plot(Xtest,Y);



Y=simGaussian(Xtest,'gaussian',1,%eps*100,ns=10 );
plot(Xtest,Y)



//// 2D simulation 
 
nx=20; //size of mesh,  size of covariance matrix = n^2*n^2!!!
// simulate 2D
X1=(linspace(-1,1,nx));
X2=(linspace(-2,2,nx))';
// creates point matrix for simulation
X=[X1; ones(X1)]'.*.[ones(X2) X2];
Y=simGaussian([X(:,1) X(:,$)],'gaussian',[1 0.7],%eps*10000);

// splits Y to Z for ploting
Z=[];

for i=1 :nx
    Z=[Z; Y((i-1)*nx+1:(i)*nx)'];
end;
scf;
mesh(X1,X2,Z);


