function [ybest, xbest]=EGO_best(opt)
//Returns the best known point and corresponding criterion value.
//  
// Calling Sequence
//           [ybest, xbest]=EGO_best(opt)
//      
//
// Parameters
//            opt: mlist of type EGO.
//            
// Output
//            ybest: best criterion value;
//            xbest: point (row vector) for best value.
//Description 
//Returns the best known point and corresponding criterion value.
//
//Examples
// See EGO or demos.
//
//See also  
//              EGO
//              EGO_ask
//              EGO_tell
//              EGO_ask
//              EI
//              km
//              findTheta
//              
//Authors
//          Janis Janusevskis, 3MI/EMSE
//Bibliography   
//           Jones D.R., Schonlau M. and Welch W.J. (1998), Efficient Global Optimization of Expensive Black-Box Functions, Journal of Global optimization, 13:, 455-492.
//Pujol G., Le Riche R. (2007). Description de l'architecture Scilab pour le projet RNTL/OMD.
//
 
  ybest=opt.fmin;
  xbest=opt.xmin;
endfunction;


