function [out]=EGO_stop(opt)
//Ask optimizer if stopping criterion has been met.
//  
// Calling Sequence
//           [out]=EGO_stop(opt)
//      
//
// Parameters
//            opt: mlist of type EGO.
//            
// Output
//            out: True if stopping criterion has been met, False otherwise.
//Description 
//
//          Ask optimizer, if any of stopping criteria have been met.
//Examples
// See EGO or demos.
//
//See also  
//              EGO
//              EGO_best
//              EGO_tell
//              EGO_ask
//              EI
//              km
//              findTheta
//              
//Authors
//          Janis Janusevskis, 3MI/EMSE
//Bibliography   
//           Jones D.R., Schonlau M. and Welch W.J. (1998), Efficient Global Optimization of Expensive Black-Box Functions, Journal of Global optimization, 13:, 455-492.
//Pujol G., Le Riche R. (2007). Description de l'architecture Scilab pour le projet RNTL/OMD.
//
 
  
  out=opt.stop;
  
  if opt.stop & opt.perf then
      if opt.perfData.maxEis($) < opt.stopCrit then disp('Optimization stoped. maxEi < stopEi.');end;
      if opt.it>= opt.maxit then disp('Optimization stoped. Maximum number of iterations reached.');end;
  end;

endfunction;
