function  [v, dv] = exponential_1_9(d,theta)
//Exponential correlation function.
//  
// Calling Sequence
//            [v] = exponential_1_9(d,theta)
//            [v, dv] = exponential_1_9(d,theta)
//
// Parameters
//            d:  disstance between points (m*n) matrix. m - number of distances, n - number of dimensions.
//            theta: lenght scale hyperparameter (1*n) row vector or scalar (to use the same scale for all dimensions).
//
// Output
//            v: correlation (m*1) column vector.
//            dv: derrivative (not implemented).
//
//Description
//Gaussian correlation function.          
//Examples
//v=exponential_1_9(3,1); 
//See also
//           km
//           findTheta
//           simGaussian

//           matern_5_2
//Authors
//          Janis Janusevskis, 3MI/EMSE
//Bibliography 
//
//
p=1.9;// smoothnes coefficent
[m n] = size(d);  // number of distances and dimension of data
[mt nt]=size(theta);
if  mt == 1 & nt==1 then
  theta = ones(1,n) .*. theta;
elseif  nt ~= n | mt ~= 1 then
  error(sprintf('Length of theta must be 1*1  or 1*%d',n))
end
theta=ones(m,1)*theta;
//v=nugget*prod(exp(-(d./theta)^p)); nozimetu

v=prod(exp(-(abs(d)./theta)^p),'c');
dv=%nan;

endfunction





