function [f,df]=poly0(x)
//Constant trend function.
//
//Calling Sequence
//           f = poly0(x)
//
// Parameters
//         x:  m*n matrix with design sites
// Output
//        f: ones(m,1)
//        df: derivatives(not implemented);
//
//Description
//Zero order polynomial regression function
//Examples
//
//// 1D example
//// zero noise
//x_bound=[-2; 2];
//X=(linspace(x_bound(1),x_bound(2),4))'; // Points of experiment
//YExp=sin(X);// Response values
//noise=0;theta=1;
//[kmodel] =km(X,YExp,poly0,'gaussian',theta,noise);
//[kmodel] =km(X,YExp,0,'gaussian',theta,noise);
//
//
//See also
//           poly1
//           poly2
//           km
//           findTheta
//           simGaussian
//           SimCondGaussian
//Authors
//          Janis Janusevskis, 3MI/EMSE
//Bibliography 
//
//
  [m,n] = size(x);
  f = ones(m,1);
endfunction;


