function [out]=showModel(model)
//  Displays information about kriging model.
//
//  Calling Sequence    
//          showmodel(model)
// Parameters
//          model: kriging model.
//  
//Description
// Displays information about kriging model.
//Note: This function uses global variable Beta_kriging;
//
//Examples
// See demos directory for more examples.
//See also
//           km
//           findTheta
//           simGaussian
//           SimCondGaussian
//Authors
//          Janis Janusevskis, 3MI/EMSE
//Bibliography 
//
//

  global Beta_kriging;

printf("Krigin model: \n");      
printf("  Number of points: %i;  number of dimensions: %i\n",model.m, model.n);      
printf("  Trend coef.: "+string(Beta_kriging)+" \n");
printf("  Process variance: "+string(model.sigma)+" \n");
printf("  Process standard deviation: "+string(sqrt(model.sigma))+" \n");
printf("  Noise variance: "+string(model.noise)+" \n");
printf("  Noise standard deviation: "+string(sqrt(model.noise))+" \n");

str=string(model.theta);strT="";
for i=1:size(str,'c') strT=strT+ "  "+str(:,i);end;
printf("  Thetas: "+strT+" \n");
printf("  Negative Log-Likelihood: "+string(model.MLL)+" \n");
out=[];
endfunction;
